3.4.10 (2017-04-05)
===================
Improvements
------------
- Dark theme: table header are colored on Windows
- updated SWT to version 4.749

Fixed Bugs
----------
- Dark theme:
  - "No more changes" popup hard to read on Ubuntu
  - tree controls might look strange on OS X, especially with selection
- different Editors: Home key did not move caret to document home (if 
  line-vs-document option was unselected)
- Changes, Current Lines display: possible internal error while painting
- GUI:
  - maximized and fullscreen state were not handled correctly
  - OS X: opening a non-fullscreen window from a fullscreen window did not 
    switch to separate desktop
    <https://bugs.eclipse.org/bugs/show_bug.cgi?id=509741>
  - File completion: incorrect position of popup
    <https://bugs.eclipse.org/bugs/show_bug.cgi?id=509514>


3.4.9 (2016-12-15)
==================
Improvements
------------
- Dark theme support
- Directory Compare: show change count in status bar icon
- updated SWT to version 4.723

Fixed Bugs
----------
- File Compare: Ctrl+C in left or right file input field does not work
  (accelerator Ctrl+C is triggered instead)


3.4.8 (2016-11-11)
==================
Improvements
------------
- Compare: optionally show long current lines for left-right layout
- Compare, Merge: ability to select syntax highlighting language
- Autoupdate: don't show "Started downloading version ..." notification, but
  only success for less distraction
- Tree control (Linux): added expanding/collapsing using cursor-right/left

Fixed Bugs
----------
- Bootloader did not work with Java 1.9
- possible progress-bar-related internal error
- possible syntax-coloring-related internal error
- Linux: possible internal error if GTK stops to create menu items


3.4.7 (2016-08-22)
==================
Improvements
------------
- File compare, merge:
  - smart tab: if multiple lines are selected, pressing tab indents (inserts
    leading tab characters) and shift-tab unindents (removes leading tab/space
    characters)
  - improved detection of inner-line changes
- File completion:
  - entering an upper-case character preselects the upper-case file/directory
  - ESC closes popup, clicking ESC again in dialog will close the dialog

Fixed Bugs
----------
- File compare, merge:
  - Apply Lines might add instead of replace lines
  - undoing changes out of view did not scroll to undone change
- deb-bundle: had wrong dependencies
- Windows bundle: upgrading to new build kept InnoSetup uninstall files in old
  directory
- OS X: clicking dock icon put window to front even if application modal
  dialogs like preferences or about were shown
- tree controls: internal error expanding parent node of single-child nodes
  (that automatically expand)
- table controls: double-click action was triggered by all kinds of double-
  mouse-clicks, not just be left-double-clicks


3.4.6 (2016-07-24)
==================
Improvements
------------
- File compare:
  - ability to drop files into the left or right pane
  - dark theme
- Directory compare: ability to ignore further read errors
- GUI:
  - multi-monitor support: parent-less dialog, e.g. preferences, are shown
    on monitor where all other windows are shown, not necessarily on the
    main monitor

Fixed Bugs
----------
- File compare:
  - under certain conditions an equal block could be marked as changed
  - changing color in preferences not always refreshed the panes immediately
- starting a second instance failed to connect to running instance
- internal error for extremely deep directory structures (progress related)
- GUI:
  - full-screen option is not available on Linux (Gnome 3), because a dialog
    on top of a full-screen window is not visible
  - file completion popup could be too narrow on Linux

Changes
-------
- requires Java 1.8


3.4.5 (2016-03-15)
==================
Improvements
------------
- About: added Register button
- Compare/Merge: ability to apply multiple lines to other pane
- License Information dialog: shows life-long updates
- Welcome dialog: ability to open multiple profiles

Fixed Bugs
----------
- Directory compare: scrolling in Files table using keyboard caused massive
  thread creation
- HiDPI: some fixes
- Linux:
  - debian bundle could not find license.html
  - some checkboxes were not aligned correctly with their label
- OS X:
  - odd-looking notification icon
  - updater had no dock icon
- updated SWT to 4.614 fixing a couple of Linux/GTK3 bugs


3.4.4 (2015-11-30)
==================
Improvements
------------
- HiDPI-support
- Subscriptions: allow to register outdated but valid license (by fetching the
  latest license)
- Linux launchers: added StartupWMClass
- minor GUI improvements

Fixed Bugs
----------
- Compare:
  - the focus sometimes was moved to the read-only side
  - Find dialog:
    - previous text was not preselected
    - after showing this dialog, the focus was lost
  - if Sync is running, command line paramters get ignored
- fixed a couple of seldom crashes
- minor text fixes


3.4.3 (2015-07-03)
==================
Improvements
------------
- About dialog: ability to update installation directory
- Autoupdate:
  - when configured to only report a new version, allow to trigger the download
    from the notification
  - better cleanup of older builds
- Directory Compare: show progress in task bar icon
- Table filtering: changing the filter automatically selects first row

Fixed Bugs
----------
- Autupdate: may fail because running instance could not be exited correctly
- Docking: drag-and-drop preview showed non-rectangular form
- Encoding: internal error selecting, e.g., x-JISAutoDetect
- File Compare, View Settings: "Trim equal start/end of inner-line change" was
  not remembered
- File Compare/Merge: refresh did not reload files form disk
- Notifications: may have stolen focus
- OS X:
  - parent-less dialogs could get maximized if other windows were maximized
  - possible z-order problems of windows
  - work-around for nasty problems on OS X 10.11


3.4.2 (2015-02-02)
==================
Fixed Bugs
----------
- Directory Compare:
  - internal error typing characters using IME (speed-search)
- File Compare:
  - Reload was not enabled
  - Save: selected line separator is not remembered
- File Merge:
  - serious performance problem for large files with a lot of changes
  - current-line highlight did not work
  - change-stripe with X-buttons with zero height
- Autoupdate: several fixes
- Undo/Redo keystrokes performed two steps


3.4.1 (2014-11-28)
==================
Fixed Bugs
----------
- New Directory Compare dialog: possible internal error with empty first
  input field
- Directory Compare: possible internal closing window while still scanning
- OS X 10.10 (Yosemite):
  - updated signature
  - right-clicking table header did not show column popup
- if non-commercial edition had been selected in v3.3, a commercial
  evaluation was started silently with v3.4


3.4 (2014-11-06)
================
Improvements
------------
- Auto-update: can update full installation
- Linux: easier JRE configuration by adding a
  jre=/path/to/jre
  line to ~/.smartsynchronize/smartsynchronize.vmoptions
- tables: automatically select next line
- completely reworked accelerator handling
- support for subscription licenses

Fixed Bugs
----------
- UTF-8-detection from content was not enabled by default
- visual feed-back of drag-and-drop to input fields was broken
- obsolete notifications might have been shown
- bugs could not cause Gigs of bug*.zip files any more
- OS X:
  - work-around for broken search input field on OS X 10.10
- Linux:
  - internal error dropping file from network share onto input field
  - work-around for Cairo-related crash


3.3.6 (2014-10-09)
==================
Improvements
------------
- Compare: for some programming languages the compare results have been
  improved for sophisticated code changes
- minor GUI improvements

Fixed Bugs
----------
- Compare:
  - Export as HTML: internal error when invoked without opened files
  - UTF-encoded text files with BOM were written incorrectly (double BOM)
- Directory Compare:
  - Refresh: possible internal error


3.3.5 (2014-08-15)
==================
Improvements
------------
- File Compare: better results are achieved for files with larger changes
- File Merge: when applying to a conflict block, the next change is not
  scrolled to automatically
- license files inside .zip files are recognized
- Notifications: if multiple notifications are shown, buttons allow to navigate
  to prev or next notification
- OS X: speed search popup looks better
- Tree control: speed search searches only visible nodes
- UTF-8 encoded text files without BOM should be detected now

Fixed Bugs
----------
- File Compare: possible internal error scrolling using mouse wheel
- OS X: some controls might be cut-off a little bit
- Resources were not disposed correctly


3.3.4 (2014-05-13)
==================
Improvements
------------
- File Compare:
  - if Name column is too narrow, the text will be truncated in the middle
- Compare:
  - whitespaces in inner-line changes are highlighted as well as trailing
    whitespaces (configurable color) by default
  - navigation to previous/next changes moves focus to side with larger
    block resulting in better visibility of changes
- OS X: chooser buttons in flat-style seem to look better
- Preferences: current-line highlighting can be disabled
- easier way to send bug-reports for internal errors (emails should not be
  necessary for most configurations)

Fixed Bugs
----------
- Compare:
  - possible internal error for text completion (Ctrl+Space)
  - possible internal error trying to export HTML for binary file diff
  - current line color was even used while not focused
- Exit some native resources were not released correctly
- File Compare:
  - Take Left/Right: internal error when IO-error happened
  - Edit|Copy Selected Information was broken
  - new table columns were invisible because of default zero width
  - speed search: fixed potential internal error
  - View|Right-Only Files: wrong tooltip
- Linux: tiny popup, e.g. "no more changes" in the Changes view, were not
  visible (hidden immediately)
- Notifications:
  - might not be closable when having clicked the status bar icon though they
    already were showing
  - might have been shown in wrong z-order
- OS X:
  - Edit|Customize and tooltips: showed + between modifiers
  - table columns were too narrow
  - OS X 10.9: vertical misalign of color buttons in preferences
- Windows: logging out/shutting down did not invoke shutdown hooks

Other Noteworthy Changes
------------------------
- requires Java 7
- EOF signs are not drawn any more (redundant)
- OS X: updates are stored in "~/Library/Application Support/SmartSynchronize"


3.3.3 (2014-01-14)
==================
Improvements
------------
- File Compare/Merge: current line is highlighted
- gutter foreground color is configurable
- Windows: better looking disabled icons

Fixed Bugs
----------
- Merge:
  - possible internal while editing
  - mouse wheel did not work in connector area
- OS X:
  - Compare/Merge editor: pressing Up/Down in first/last line did not put
    caret at first or last position
  - possible internal error clicking the dock icon
- Change stripe: flickered while scrolling larger files
- a couple of fine tuning regarding compare view, especially for the gutter


3.3.2.1 (2013-10-21)
====================
Fixed Bugs
----------
- Linux:
  - VM crash on Ubuntu 13.10 (see
    <https://bugs.eclipse.org/bugs/show_bug.cgi?id=419729>)
  - class com.sun.jna.platform.FileUtils not found


3.3.2 (2013-10-16)
==================
Improvements
------------
- OS X: clicking the dock icon when there are only minimized windows will
  restore the last used one

Fixed Bugs
----------
- Directory Compare:
  - possible internal error closing the window while a compare was running
  - sorting related internal error with Java 7 and certain file names
- File Compare/Preview: on OS X the unified scrollbar was only visible when
  scrolling
- File Compare/Merge:
  - syntax-related internal error while entering text using an
    input method editor (IME)
  - "Autoindent new line" did not work correctly using an IME

Other Changes
-------------
- removed dependency on JFace


3.3.1 (2013-08-20)
==================
Improvements
------------
- added 64-bit launcher to portable bundle
- added Window|Maximize
- OS X: handles dock icon clicks

Fixed Bugs
----------
- File Compare opened from Directory Compare: possible dead-lock clicking
  Save All
- File Compare, Save All: after saving the toolbar button remained enabled
- after registering a license file and clicking Restart, no restart occurred
- Windows 7: pinned status bar icon changed after update
- the window maximized state was not restored correctly on some machines
- New File Compare: no possibility to select encoding
- minor potential resource leak


3.3 (2013-04-19)
================
Improvements
------------
- Syntax coloring: support for more languages, e.g. Basic, Pascal

Fixed Bugs
----------
- File Compare: [<<], [X] and [>>] buttons could be invoked by clicks using
  not only the left mouse button
- File Merge:
  - possible internal error when closing too quickly
  - displayed paths are not using ~/ prefix on OS X/Linux
- Directory Compare, OS X: Help menu was missing
- Windows, High-contrast theme: internal error on startup
- Check for New Version:
  - when selecting Download, the files were not downloaded immediately
  - possible internal error in case of connection problems
- Syntax Coloring: possible internal error


3.3 rc 2 (2013-04-03)
=====================
Improvements
------------
- added Help|Check for Latest Build
- signed .dmg file for OS X instead of .tar.gz

Fixed Bugs
----------
- could not launch on OS X with Java 6
- internal error starting without settings
- possible dead-lock after showing the welcome dialog
- Directory Compare: Synchronize did not work
- File Compare/Merge, OS X: no space between toolbar and content


3.3 rc 1 (2013-03-28)
=====================
Improvements
------------
- syntax highlighting C/C++: added *.h pattern
- show reasonable help when invoking with --help from command line

Fixed Bugs
----------
- tooltips were hidden too quickly
- OS X: added work-around for certain Java-7-related problems (see
  https://bugs.eclipse.org/bugs/show_bug.cgi?id=388886 and
  https://bugs.eclipse.org/bugs/show_bug.cgi?id=399845)
- Directory Compare:
  - Changes preview: unselecting a file caused the right scrollbar to remain
  - Synchronize dialog:
    - space-toggling the checkboxes was broken
    - buggy display of Change table column


3.3 preview 7 (2013-03-19)
==========================
Improvements
------------
- ability to open empty file compare for comparing copy/pasted text
- File Compare: ability to save as
- auto-update to new version
- show tabs/spaces using unicode characters instead of painted ones
- File Merge: only if VM property smartsynchronize.merge.autoMerge
  is set to true, auto-merge will happen

Fixed Bugs
----------
- Apply Left/Right dialog, Save Profile: did not show/use ~/ for
  paths in home directory
- Directory Compare: table speed-search did not select the correct row
  for sorted tables
- File Merge: merged and right paths above editors were swapped
- Linux: some table columns might disappear on refresh
- internal error in speed-search when using IME for typing Chinese
  characters


3.3 preview 6 (2013-02-15)
==========================
Improvements
------------
- syntax coloring configurable in preferences
- New File Compare/Merge:
  - don't allow to reuse window if modified
  - encoding can be specified when opening

Fixed Bugs
----------
- internal error when merging
- File Merge: toggling "Ignore Whitespace" option had no effect
- OS X bundle contained invalid version
- portable bundle: invalid settings path


3.3 preview 5 (2013-01-28)
==========================
Improvements
------------
- syntax coloring
- support for Solaris
- ability to configure whether Home/End operate on line or document
- file/directory input fields: full support for ~ (OS X, Linux)

Fixed Bugs
----------
- internal error opening file compare from command line
- Directory Compare: files with different content in last line and no line
  separator after last line were detected as "Different EOL" instead of,
  e.g., "Changed"
- different text editor option in the preferences did not work
- File Compare: screwed-up look
- OS X: system shutdown caused SmartSynchronize to hang

3.3 preview 4 (2012-11-06)
==========================
Improvements
------------
- Directory compare:
  - ability to copy name of selected file or directory
  - ability to easily ignore file or directory
  - natural sorting (file-10.txt after file-9.txt)
  - context menus

Fixed Bugs
----------
- Directory compare profiles: internal error moving profile up or down
  using the corresponding buttons


3.3 preview 3 (2012-08-08)
==========================
Improvements
------------
- Directory compare:
  - Synchronize dialog:
    - better looking checkboxes
    - remembers size and position
  - file name filter: if no matching files were found in the type filtered
    (visible) files, in non-type-matching (hidden) files is searched

Fixed Bugs
----------
- Directory compare, Synchronize: fixed info message and dialog text in case
  of synchronizing a directory compare (no profile)
- Merge on OS X: internal error
- notification popup: several small fixes
- OS X, message dialogs: fixed tab order


3.3 preview 2 (2012-06-07)
==========================
Improvements
------------
- full-screen support, even for OS X 10.7

Fixed Bugs
----------
- File Compare opened from Directory Compare: internal error saving a file
- Directory Compare: huge tabs on certain Linux themes
- Compare or Merge:
  - internal error when quickly applying changes
  - search and replace did not work correctly
- internal error trying to copy too much text
- after closing all notifications, a small gray popup remained
- OS X:
  - file completion popup did not follow caret
  - could not use ESC as accelerator


3.3 preview 1 (2012-05-21)
==========================
Improvements
------------
- a new GUI library is used (SWT) to improve the look and responsiveness
- Directory Compare: ability to open a file pair detected as binary
- option to turn off splash screen (smartsynchronize.properties)
- more dialog sizes are remembered

Fixed Bugs
----------
- the settings dialog could become too large depending on the configured
  exclusion patterns
